import { HTMLTemplateResult, LitElement } from "lit";
import { DecisionComponent } from "../decision/decision";
declare const VerificationBootstrapComponent_base: new (...args: any[]) => LitElement;
/**
 * @description
 * A dialog that contains informative animations about the verification grid and
 * how to use it.
 *
 * @event open - Dispatched when the dialog is opened
 * @event close - Dispatched when the dialog is closed
 */
export declare class VerificationBootstrapComponent extends VerificationBootstrapComponent_base {
    static styles: import("lit").CSSResult[];
    private injector;
    decisionElements: DecisionComponent[];
    hasVerificationTask: boolean;
    hasClassificationTask: boolean;
    isMobile: boolean;
    private slides;
    private dialogElement;
    private tutorialSlideCarouselElement;
    private isAdvancedDialog;
    get open(): Readonly<boolean>;
    private get autoDismissPreference();
    private set autoDismissPreference(value);
    private get decisionShortcuts();
    private get demoDecisionButton();
    firstUpdated(): void;
    showTutorialDialog(): void;
    showAdvancedDialog(): void;
    private closeDialog;
    private showDialog;
    private positiveDecisionColor;
    private negativeDecisionColor;
    private renderSlide;
    private slideFooterTemplate;
    private slidesTemplate;
    render(): HTMLTemplateResult;
}
declare global {
    interface HTMLElementTagNameMap {
        "oe-verification-bootstrap": VerificationBootstrapComponent;
    }
}
export {};
