import { LitElement, PropertyValues, TemplateResult } from "lit";
import { UrlSourcedFetcher } from "../../services/urlSourcedFetcher";
declare const DataSourceComponent_base: new (...args: any[]) => LitElement;
/**
 * @description
 * Automatically creates a PageFetcher callback that can be used on a
 * verification grid component
 *
 * @csspart file-picker - A css target to style the file picker button
 */
export declare class DataSourceComponent extends DataSourceComponent_base {
    static styles: import("lit").CSSResult;
    /** A remote JSON or CSV file to use as the data source */
    src?: string | File;
    /**
     * A verification grid component that the derived page fetcher callback will
     * be applied to
     */
    for: string;
    /** Whether to allow for local file inputs through a system UI dialog */
    local: boolean;
    /** Randomly sample rows from a local or remote data source */
    random: boolean;
    private canDownload;
    private fileName?;
    private fileInput;
    urlSourcedFetcher?: UrlSourcedFetcher;
    private verificationGrid?;
    private decisionHandler;
    willUpdate(changedProperties: PropertyValues<this>): void;
    downloadResults(): Promise<void>;
    private downloadCallbackSourcedResults;
    private downloadUrlSourcedResults;
    private resultRows;
    private isUrlSourced;
    private handleDecision;
    private handleFileChange;
    private updateVerificationGrid;
    private fileInputTemplate;
    render(): TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        "oe-data-source": DataSourceComponent;
    }
}
export {};
