import { Verification } from "../../../models/decisions/verification";
import { DecisionComponent, DecisionModels } from "../decision";
import { DecisionOptions } from "../../../models/decisions/decision";
import { KeyboardShortcut } from "../../../templates/keyboardShortcut";
import { Tag } from "../../../models/tag";
/**
 * @description
 * A decision that when made will emit a Verification decision
 * and additional tags in the form of Classification models
 *
 * @slot - Additional content to be displayed in the decision button
 *
 * @csspart decision-button - The button that triggers the decision
 *
 * @event decision
 */
export declare class VerificationComponent extends DecisionComponent {
    verified: DecisionOptions;
    /** Value that will be added to the oe-additional-tags column */
    additionalTags: Tag[];
    /** A keyboard key that when pressed will act as a click event on the button */
    shortcut: string;
    private decisionButton;
    get decisionModels(): Partial<DecisionModels<Verification>>;
    private _decisionModels;
    shortcutKeys(): KeyboardShortcut[];
    protected handleShortcutKey(event: KeyboardEvent): void;
    protected isShortcutKey(event: KeyboardEvent): Readonly<boolean>;
    protected handleDecision(): void;
    private generateDecisionModels;
    private additionalTagsTemplate;
    render(): import("lit").TemplateResult<1>;
}
