import { LitElement } from "lit";
declare const IndicatorComponent_base: new (...args: any[]) => LitElement;
/**
 * @description
 * A red line that displays the playback position on a spectrogram
 *
 * @csspart indicator-line - A css target to style the indicator line
 * @csspart seek-icon - A css target to style the seek icon underneath the indicator line
 *
 * @slot - A spectrogram component to add an indicator to
 */
export declare class IndicatorComponent extends IndicatorComponent_base {
    static styles: import("lit").CSSResult;
    private spectrogram?;
    private indicatorSvg;
    private unitConverter?;
    private computedTimePx;
    handleSlotChange(): void;
    private handleCanvasResize;
    render(): import("lit").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        "oe-indicator": IndicatorComponent;
    }
}
export {};
