import { LitElement, TemplateResult } from "lit";
import { SubjectWrapper } from "../../models/subject";
declare const InfoCardComponent_base: new (...args: any[]) => LitElement;
/**
 * @description
 * Displays information about a verification tile subject
 */
export declare class InfoCardComponent extends InfoCardComponent_base {
    static styles: import("lit").CSSResult;
    model?: SubjectWrapper;
    /** Number of subject key/values pairs to show before the "Show More" button is clicked */
    defaultLines: number;
    private showExpanded;
    private identityStrategy;
    private numberStrategy;
    private urlStrategy;
    private subjectRowCount;
    /**
     * Converts a url into a human readable format
     * by using the format https://.../last-path?first-parameter...
     */
    private formatUrl;
    private subjectRowTemplate;
    private subjectTemplate;
    private showMoreButtonTemplate;
    render(): TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        "oe-info-card": InfoCardComponent;
    }
}
export {};
