import { Tag } from "../models/tag";
export declare const booleanConverter: (value: string | null) => boolean;
export declare const arrayConverter: <T = unknown>(value: string | null | T[]) => T[];
export declare const tagArrayConverter: (value: string | null) => Tag[];
export declare const tagConverter: (value: string | null) => Tag;
/**
 * this callback allows the user to define a callback in the attribute
 *
 * @param value - the value of the attribute as a string or a function
 *
 * @example
 * ```html
 * <oe-spectrogram get-page="() => console.log('do something')">
 * </oe-spectrogram>
 * ```
 */
export declare const callbackConverter: (value: string | ((...params: any) => any)) => Function;
export declare const enumConverter: <T extends Readonly<{
    [key: number]: string | number;
}>>(enumValues: T) => (value: string) => T[keyof T] | undefined;
