import { Size } from "../../models/rendering";
import { IAudioInformation, SpectrogramOptions } from "./models";
export declare class AudioHelper {
    private readonly spectrogramWorker;
    private readonly state;
    private readonly sampleBuffer;
    private cachedResponse;
    private cachedAudioInformation;
    private offscreenCanvas;
    private generationData;
    private segmentSize;
    private generation;
    constructor();
    get canvasTransferred(): boolean;
    connect(src: string, canvas: HTMLCanvasElement, options: SpectrogramOptions): Promise<IAudioInformation>;
    changeSource(src: string, options: SpectrogramOptions): Promise<IAudioInformation>;
    regenerateSpectrogram(options: SpectrogramOptions): Promise<void>;
    resizeCanvas(size: Size): void;
    private abort;
    /**
     * Internal render function. Does not check if we need to abort.
     * @param options the spectrogram options
     * @param generation the generation number
     * @param src  if provided fetches the audio at the supplied source, otherwise clones a buffer of the last response
     */
    private render;
    private createAudioInformation;
    private fetchAudio;
    private cachedBuffer;
    private createAudioContext;
    private setupWorker;
    private setupProcessor;
    private clearCanvas;
    private regenerateWorker;
}
