/// <reference types="@types/audioworklet" />
/**
 * Runs once and only once to add samples to a buffer.
 * A new processor is needed for each render.
 * We keep a track of the generation to ensure the processor discards
 * samples from multiple concurrent processors invoking process.
 */
export default class BufferBuilderProcessor extends AudioWorkletProcessor {
    private state;
    private buffer;
    private aborted;
    private generation?;
    private tag;
    constructor();
    /**
     * @param inputs - is an array of inputs, each having an array of channels, with an array of samples
     */
    process(inputs: Float32Array[][]): boolean;
    private needsToAbort;
    private handleMessage;
}
