import chroma from "chroma-js";
export type RgbTuple = [r: number, g: number, b: number];
export type IntensityTuple = [ri: number, gi: number, bi: number];
export type ColorScaler = (intensity: number) => RgbTuple;
export type Color = string;
export declare const colorScales: Record<Color, chroma.BrewerPaletteName | ColorScaler>;
export type ColorMapName = keyof typeof colorScales;
export declare function getColorScale(name: ColorMapName): ColorScaler;
