import { WindowFunctionName } from "fft-windowing-ts";
import { Sample, Hertz } from "../../models/unitConverters";
import { ColorMapName } from "./colors";
export interface IAudioInformation {
    startSample: Sample;
    endSample: Sample;
    sampleRate: Hertz;
    channels: number;
    duration: number;
}
export declare class SpectrogramOptions {
    constructor(windowSize: number, windowOverlap: number, windowFunction: WindowFunctionName, melScale: boolean, brightness: number, contrast: number, colorMap: ColorMapName);
    /**
     * number of samples in each window for the fft
     * must be a power of 2
     */
    windowSize: number;
    /** number of samples to overlap between windows */
    windowOverlap: number;
    windowFunction: WindowFunctionName;
    melScale: boolean;
    brightness: number;
    contrast: number;
    colorMap: ColorMapName;
    get windowStep(): number;
}
