import { EnumValue } from "../../helpers/types/advancedTypes";
import { Tag } from "../tag";
/** The decision states that can be applied to a tag */
export declare enum DecisionOptions {
    FALSE = "false",
    TRUE = "true",
    UNSURE = "unsure",
    SKIP = "skip"
}
/**
 * @description
 * A polymorphic structure that can be used to represent any decision type
 * that implements the abstract class
 */
export declare class Decision {
    constructor(confirmed: EnumValue<DecisionOptions>, tag?: Tag);
    /** Stores the decision outcome */
    readonly confirmed: EnumValue<DecisionOptions>;
    /** A tag that the decision was made about */
    readonly tag: Tag;
}
