import { EnumValue } from "../../helpers/types/advancedTypes";
import { Tag } from "../tag";
import { Decision, DecisionOptions } from "./decision";
/**
 * @description
 * A decision that verifies or denies the existence of a tag in a subjects
 * audio segment
 *
 * @extends Decision
 */
export declare class Verification extends Decision {
    constructor(confirmed: EnumValue<DecisionOptions>, tag?: Tag);
    /** returns a new verification instance with the tag property changed */
    withTag(tag: Tag): Verification;
}
