export type CandidateKey = string;
export type Transformer = Record<string, CandidateKey[]>;
export declare abstract class ModelParser<T> {
    protected constructor();
    abstract parse(model: Record<string, any>): T;
    protected static deriveModel(original: Record<string, unknown>, transformer: Transformer): Record<string, unknown>;
    private static getKeyPermutations;
    protected static keyTransformer(key: string[]): string[];
}
