import { Subject, SubjectWrapper } from "../models/subject";
import { ModelParser } from "./modelParser";
/**
 * A callback that will be applied to every subjects url
 * this can be useful for adding authentication information
 */
export type UrlTransformer = (url: string, subject?: Subject) => string;
export declare abstract class SubjectParser extends ModelParser<SubjectWrapper> {
    private static emittedTagArrayWarning;
    private static defaultTag;
    static parse(original: Subject, urlTransformer: UrlTransformer): SubjectWrapper;
    private static tagParser;
    private static tagArrayParser;
}
