import { HTMLTemplateResult } from "lit";
export type KeyboardShortcutKey = string | typeof shiftSymbol | typeof mouseClick;
export interface KeyboardShortcut {
    keys: KeyboardShortcutKey[];
    description?: string;
}
export declare enum ShiftSymbolVariant {
    "inline" = 0,
    "short" = 1,
    "long" = 2
}
export declare const shiftSymbol: unique symbol;
export declare const mouseClick: unique symbol;
/**
 * @description
 * A standardized template to display keyboard shortcuts and shortcut
 * combinations
 */
export declare function keyboardShortcutTemplate(shortcut: KeyboardShortcut, shiftSymbolVariant?: ShiftSymbolVariant): HTMLTemplateResult;
