import { P as N, d as W, f as h, Q as f, U as w, b as M, R as v, V as C, A as U, m as j, J as O, n as u, L as z, W as b, e as X, X as P, t as R } from "./spectrogram-C4fJ8WUO.js";
const H = W("music-metadata:id3v2:frame-parser"), p = "latin1";
function F(m) {
  const e = [];
  let t, a = "";
  for (const i of m)
    if (typeof t == "string")
      if (i === "(" && t === "")
        a += "(", t = void 0;
      else if (i === ")") {
        a !== "" && (e.push(a), a = "");
        const l = S(t);
        l && e.push(l), t = void 0;
      } else
        t += i;
    else i === "(" ? t = "" : a += i;
  return a && (e.length === 0 && a.match(/^\d*$/) && (a = S(a)), a && e.push(a)), e;
}
function S(m) {
  if (m === "RX")
    return "Remix";
  if (m === "CR")
    return "Cover";
  if (m.match(/^\d*$/))
    return O[Number.parseInt(m)];
}
class g {
  /**
   * Create id3v2 frame parser
   * @param major - Major version, e.g. (4) for  id3v2.4
   * @param warningCollector - Used to collect decode issue
   */
  constructor(e, t) {
    this.major = e, this.warningCollector = t;
  }
  readData(e, t, a) {
    if (e.length === 0) {
      this.warningCollector.addWarning(`id3v2.${this.major} header has empty tag type=${t}`);
      return;
    }
    const { encoding: i, bom: l } = N.get(e, 0), c = e.length;
    let s = 0, d = [];
    const E = g.getNullTerminatorLength(i);
    let r;
    switch (H(`Parsing tag type=${t}, encoding=${i}, bom=${l}`), t !== "TXXX" && t[0] === "T" ? "T*" : t) {
      case "T*":
      // 4.2.1. Text information frames - details
      case "GRP1":
      // iTunes-specific ID3v2 grouping field
      case "IPLS":
      // v2.3: Involved people list
      case "MVIN":
      case "MVNM":
      case "PCS":
      case "PCST": {
        let n;
        try {
          n = h(e.slice(1), i).replace(/\x00+$/, "");
        } catch (o) {
          if (o instanceof Error) {
            this.warningCollector.addWarning(`id3v2.${this.major} type=${t} header has invalid string value: ${o.message}`);
            break;
          }
          throw o;
        }
        switch (t) {
          case "TMCL":
          // Musician credits list
          case "TIPL":
          // Involved people list
          case "IPLS":
            d = g.functionList(this.splitValue(t, n));
            break;
          case "TRK":
          case "TRCK":
          case "TPOS":
            d = n;
            break;
          case "TCOM":
          case "TEXT":
          case "TOLY":
          case "TOPE":
          case "TPE1":
          case "TSRC":
            d = this.splitValue(t, n);
            break;
          case "TCO":
          case "TCON":
            d = this.splitValue(t, n).map((o) => F(o)).reduce((o, T) => o.concat(T), []);
            break;
          case "PCS":
          case "PCST":
            d = this.major >= 4 ? this.splitValue(t, n) : [n], d = Array.isArray(d) && d[0] === "" ? 1 : 0;
            break;
          default:
            d = this.major >= 4 ? this.splitValue(t, n) : [n];
        }
        break;
      }
      case "TXXX": {
        const n = g.readIdentifierAndData(e, s + 1, c, i);
        d = {
          description: n.id,
          text: this.splitValue(t, h(n.data, i).replace(/\x00+$/, ""))
        };
        break;
      }
      case "PIC":
      case "APIC":
        if (a) {
          const n = {};
          switch (s += 1, this.major) {
            case 2:
              n.format = h(e.slice(s, s + 3), "latin1"), s += 3;
              break;
            case 3:
            case 4:
              r = f(e, s, c, p), n.format = h(e.slice(s, r), p), s = r + 1;
              break;
            default:
              throw V(this.major);
          }
          n.format = g.fixPictureMimeType(n.format), n.type = U[e[s]], s += 1, r = f(e, s, c, i), n.description = h(e.slice(s, r), i), s = r + E, n.data = e.slice(s, c), d = n;
        }
        break;
      case "CNT":
      case "PCNT":
        d = w.get(e, 0);
        break;
      case "SYLT": {
        const n = C.get(e, 0);
        s += C.len;
        const o = {
          descriptor: "",
          language: n.language,
          contentType: n.contentType,
          timeStampFormat: n.timeStampFormat,
          syncText: []
        };
        let T = !1;
        for (; s < c; ) {
          const x = g.readNullTerminatedString(e.subarray(s), n.encoding);
          if (s += x.len, T) {
            const L = w.get(e, s);
            s += w.len, o.syncText.push({
              text: x.text,
              timestamp: L
            });
          } else
            o.descriptor = x.text, T = !0;
        }
        d = o;
        break;
      }
      case "ULT":
      case "USLT":
      case "COM":
      case "COMM": {
        const n = v.get(e, s);
        s += v.len;
        const o = g.readNullTerminatedString(e.subarray(s), n.encoding);
        s += o.len;
        const T = g.readNullTerminatedString(e.subarray(s), n.encoding);
        d = {
          language: n.language,
          descriptor: o.text,
          text: T.text
        };
        break;
      }
      case "UFID": {
        const n = g.readIdentifierAndData(e, s, c, p);
        d = { owner_identifier: n.id, identifier: n.data };
        break;
      }
      case "PRIV": {
        const n = g.readIdentifierAndData(e, s, c, p);
        d = { owner_identifier: n.id, data: n.data };
        break;
      }
      case "POPM": {
        r = f(e, s, c, p);
        const n = h(e.slice(s, r), p);
        s = r + 1;
        const o = c - s;
        d = {
          email: n,
          rating: M.get(e, s),
          counter: o >= 5 ? w.get(e, s + 1) : void 0
        };
        break;
      }
      case "GEOB": {
        r = f(e, s + 1, c, i);
        const n = h(e.slice(s + 1, r), p);
        s = r + 1, r = f(e, s, c, i);
        const o = h(e.slice(s, r), p);
        s = r + 1, r = f(e, s, c, i);
        const T = h(e.slice(s, r), p);
        s = r + 1, d = {
          type: n,
          filename: o,
          description: T,
          data: e.slice(s, c)
        };
        break;
      }
      // W-Frames:
      case "WCOM":
      case "WCOP":
      case "WOAF":
      case "WOAR":
      case "WOAS":
      case "WORS":
      case "WPAY":
      case "WPUB":
        r = f(e, s + 1, c, i), d = h(e.slice(s, r), p);
        break;
      case "WXXX": {
        r = f(e, s + 1, c, i);
        const n = h(e.slice(s + 1, r), i);
        s = r + (i === "utf-16le" ? 2 : 1), d = { description: n, url: h(e.slice(s, c), p) };
        break;
      }
      case "WFD":
      case "WFED":
        d = h(e.slice(s + 1, f(e, s + 1, c, i)), i);
        break;
      case "MCDI": {
        d = e.slice(0, c);
        break;
      }
      default:
        H(`Warning: unsupported id3v2-tag-type: ${t}`);
        break;
    }
    return d;
  }
  static readNullTerminatedString(e, t) {
    let a = t.bom ? 2 : 0;
    const i = f(e, a, e.length, t.encoding), l = e.slice(a, i);
    return t.encoding === "utf-16le" ? a = i + 2 : a = i + 1, {
      text: h(l, t.encoding),
      len: a
    };
  }
  static fixPictureMimeType(e) {
    switch (e = e.toLocaleLowerCase(), e) {
      case "jpg":
        return "image/jpeg";
      case "png":
        return "image/png";
    }
    return e;
  }
  /**
   * Converts TMCL (Musician credits list) or TIPL (Involved people list)
   * @param entries
   */
  static functionList(e) {
    const t = {};
    for (let a = 0; a + 1 < e.length; a += 2) {
      const i = e[a + 1].split(",");
      t[e[a]] = t[e[a]] ? t[e[a]].concat(i) : i;
    }
    return t;
  }
  /**
   * id3v2.4 defines that multiple T* values are separated by 0x00
   * id3v2.3 defines that TCOM, TEXT, TOLY, TOPE & TPE1 values are separated by /
   * @param tag - Tag name
   * @param text - Concatenated tag value
   * @returns Split tag value
   */
  splitValue(e, t) {
    let a;
    return this.major < 4 ? (a = t.split(/\x00/g), a.length > 1 ? this.warningCollector.addWarning(`ID3v2.${this.major} ${e} uses non standard null-separator.`) : a = t.split(/\//g)) : a = t.split(/\x00/g), g.trimArray(a);
  }
  static trimArray(e) {
    return e.map((t) => t.replace(/\x00+$/, "").trim());
  }
  static readIdentifierAndData(e, t, a, i) {
    const l = f(e, t, a, i), c = h(e.slice(t, l), i);
    return t = l + g.getNullTerminatorLength(i), { id: c, data: e.slice(t, a) };
  }
  static getNullTerminatorLength(e) {
    return e === "utf-16le" ? 2 : 1;
  }
}
class D extends j("id3v2") {
}
function V(m) {
  throw new D(`Unexpected majorVer: ${m}`);
}
const $ = new TextDecoder("ascii");
class k {
  constructor() {
    this.tokenizer = void 0, this.id3Header = void 0, this.metadata = void 0, this.headerType = void 0, this.options = void 0;
  }
  static removeUnsyncBytes(e) {
    let t = 0, a = 0;
    for (; t < e.length - 1; )
      t !== a && (e[a] = e[t]), t += e[t] === 255 && e[t + 1] === 0 ? 2 : 1, a++;
    return t < e.length && (e[a++] = e[t]), e.slice(0, a);
  }
  static getFrameHeaderLength(e) {
    switch (e) {
      case 2:
        return 6;
      case 3:
      case 4:
        return 10;
      default:
        throw I(e);
    }
  }
  static readFrameFlags(e) {
    return {
      status: {
        tag_alter_preservation: u(e, 0, 6),
        file_alter_preservation: u(e, 0, 5),
        read_only: u(e, 0, 4)
      },
      format: {
        grouping_identity: u(e, 1, 7),
        compression: u(e, 1, 3),
        encryption: u(e, 1, 2),
        unsynchronisation: u(e, 1, 1),
        data_length_indicator: u(e, 1, 0)
      }
    };
  }
  static readFrameData(e, t, a, i, l) {
    var s, d;
    const c = new g(a, l);
    switch (a) {
      case 2:
        return c.readData(e, t.id, i);
      case 3:
      case 4:
        return (s = t.flags) != null && s.format.unsynchronisation && (e = k.removeUnsyncBytes(e)), (d = t.flags) != null && d.format.data_length_indicator && (e = e.slice(4, e.length)), c.readData(e, t.id, i);
      default:
        throw I(a);
    }
  }
  /**
   * Create a combined tag key, of tag & description
   * @param tag e.g.: COM
   * @param description e.g. iTunPGAP
   * @returns string e.g. COM:iTunPGAP
   */
  static makeDescriptionTagName(e, t) {
    return e + (t ? `:${t}` : "");
  }
  async parse(e, t, a) {
    this.tokenizer = t, this.metadata = e, this.options = a;
    const i = await this.tokenizer.readToken(z);
    if (i.fileIdentifier !== "ID3")
      throw new D("expected ID3-header file-identifier 'ID3' was not found");
    return this.id3Header = i, this.headerType = `ID3v2.${i.version.major}`, i.flags.isExtendedHeader ? this.parseExtendedHeader() : this.parseId3Data(i.size);
  }
  async parseExtendedHeader() {
    const e = await this.tokenizer.readToken(b), t = e.size - b.len;
    return t > 0 ? this.parseExtendedHeaderData(t, e.size) : this.parseId3Data(this.id3Header.size - e.size);
  }
  async parseExtendedHeaderData(e, t) {
    return await this.tokenizer.ignore(e), this.parseId3Data(this.id3Header.size - t);
  }
  async parseId3Data(e) {
    const t = await this.tokenizer.readToken(new X(e));
    for (const a of this.parseMetadata(t))
      switch (a.id) {
        case "TXXX":
          a.value && await this.handleTag(a, a.value.text, () => a.value.description);
          break;
        default:
          await (Array.isArray(a.value) ? Promise.all(a.value.map((i) => this.addTag(a.id, i))) : this.addTag(a.id, a.value));
      }
  }
  async handleTag(e, t, a, i = (l) => l) {
    await Promise.all(t.map((l) => this.addTag(k.makeDescriptionTagName(e.id, a(l)), i(l))));
  }
  async addTag(e, t) {
    await this.metadata.addTag(this.headerType, e, t);
  }
  parseMetadata(e) {
    let t = 0;
    const a = [];
    for (; t !== e.length; ) {
      const i = k.getFrameHeaderLength(this.id3Header.version.major);
      if (t + i > e.length) {
        this.metadata.addWarning("Illegal ID3v2 tag length");
        break;
      }
      const l = e.slice(t, t + i);
      t += i;
      const c = this.readFrameHeader(l, this.id3Header.version.major), s = e.slice(t, t + c.length);
      t += c.length;
      const d = k.readFrameData(s, c, this.id3Header.version.major, !this.options.skipCovers, this.metadata);
      d && a.push({ id: c.id, value: d });
    }
    return a;
  }
  readFrameHeader(e, t) {
    let a;
    switch (t) {
      case 2:
        a = {
          id: $.decode(e.slice(0, 3)),
          length: R.get(e, 3)
        }, a.id.match(/[A-Z0-9]{3}/g) || this.metadata.addWarning(`Invalid ID3v2.${this.id3Header.version.major} frame-header-ID: ${a.id}`);
        break;
      case 3:
      case 4:
        a = {
          id: $.decode(e.slice(0, 4)),
          length: (t === 4 ? P : w).get(e, 4),
          flags: k.readFrameFlags(e.slice(8, 10))
        }, a.id.match(/[A-Z0-9]{4}/g) || this.metadata.addWarning(`Invalid ID3v2.${this.id3Header.version.major} frame-header-ID: ${a.id}`);
        break;
      default:
        throw I(t);
    }
    return a;
  }
}
function I(m) {
  throw new D(`Unexpected majorVer: ${m}`);
}
export {
  k as I
};
