import { g as s, U as m, a as P, b as g, c, i as h, E as f, d as x, I as v, e as S, s as z, m as E } from "./spectrogram-C4fJ8WUO.js";
import { A } from "./AbstractID3Parser-DKQDqHy1.js";
var F;
(function(a) {
  a[a.not_set = 0] = "not_set", a[a.radio = 1] = "radio", a[a.audiophile = 2] = "audiophile";
})(F || (F = {}));
var k;
(function(a) {
  a[a.unspecified = 0] = "unspecified", a[a.engineer = 1] = "engineer", a[a.user = 2] = "user", a[a.automatic = 3] = "automatic", a[a.rms_average = 4] = "rms_average";
})(k || (k = {}));
const y = {
  len: 2,
  get: (a, t) => {
    const e = s(a, t, 0, 3), i = s(a, t, 6, 1), r = s(a, t, 7, 9) / 10;
    if (e > 0)
      return {
        type: s(a, t, 0, 3),
        origin: s(a, t, 3, 3),
        adjustment: i ? -r : r
      };
  }
}, M = {
  len: 27,
  get: (a, t) => {
    const e = m.get(a, t + 2);
    return {
      revision: s(a, t, 0, 4),
      vbr_method: s(a, t, 4, 4),
      lowpass_filter: 100 * g.get(a, t + 1),
      track_peak: e === 0 ? null : e / 2 ** 23,
      track_gain: y.get(a, 6),
      album_gain: y.get(a, 8),
      music_length: m.get(a, t + 20),
      music_crc: g.get(a, t + 24),
      header_crc: P.get(a, t + 24)
    };
  }
}, w = new c(4, "ascii"), u = new c(6, "ascii"), T = {
  len: 4,
  get: (a, t) => ({
    frames: h(a, t, 31),
    bytes: h(a, t, 30),
    toc: h(a, t, 29),
    vbrScale: h(a, t, 28)
  })
};
async function L(a) {
  const t = await a.readToken(T), e = { numFrames: null, streamSize: null, vbrScale: null };
  if (t.frames && (e.numFrames = await a.readToken(m)), t.bytes && (e.streamSize = await a.readToken(m)), t.toc && (e.toc = new Uint8Array(100), await a.readBuffer(e.toc)), t.vbrScale && (e.vbrScale = await a.readToken(m)), await a.peekToken(new c(4, "ascii")) === "LAME") {
    await a.ignore(4), e.lame = {
      version: await a.readToken(new c(5, "ascii"))
    };
    const r = e.lame.version.match(/\d+.\d+/g);
    if (r !== null) {
      const p = r[0].split(".").map((_) => Number.parseInt(_, 10));
      p[0] >= 3 && p[1] >= 90 && (e.lame.extended = await a.readToken(M));
    }
  }
  return e;
}
const o = x("music-metadata:parser:mpeg");
class d extends E("MPEG") {
}
const C = 1024, b = {
  /**
   * Audio Object Types
   */
  AudioObjectTypes: [
    "AAC Main",
    "AAC LC",
    // Low Complexity
    "AAC SSR",
    // Scalable Sample Rate
    "AAC LTP"
    // Long Term Prediction
  ],
  /**
   * Sampling Frequencies
   * https://wiki.multimedia.cx/index.php/MPEG-4_Audio#Sampling_Frequencies
   */
  SamplingFrequencies: [
    96e3,
    88200,
    64e3,
    48e3,
    44100,
    32e3,
    24e3,
    22050,
    16e3,
    12e3,
    11025,
    8e3,
    7350,
    null,
    null,
    -1
  ]
  /**
   * Channel Configurations
   */
}, D = [
  void 0,
  ["front-center"],
  ["front-left", "front-right"],
  ["front-center", "front-left", "front-right"],
  ["front-center", "front-left", "front-right", "back-center"],
  ["front-center", "front-left", "front-right", "back-left", "back-right"],
  ["front-center", "front-left", "front-right", "back-left", "back-right", "LFE-channel"],
  ["front-center", "front-left", "front-right", "side-left", "side-right", "back-left", "back-right", "LFE-channel"]
];
class n {
  constructor(t, e) {
    this.bitrateIndex = null, this.sampRateFreqIndex = null, this.padding = null, this.privateBit = null, this.channelModeIndex = null, this.modeExtension = null, this.isOriginalMedia = null, this.version = null, this.bitrate = null, this.samplingRate = null, this.frameLength = 0, this.versionIndex = s(t, e + 1, 3, 2), this.layer = n.LayerDescription[s(t, e + 1, 5, 2)], this.versionIndex > 1 && this.layer === 0 ? this.parseAdtsHeader(t, e) : this.parseMpegHeader(t, e), this.isProtectedByCRC = !h(t, e + 1, 7);
  }
  calcDuration(t) {
    return this.samplingRate == null ? null : t * this.calcSamplesPerFrame() / this.samplingRate;
  }
  calcSamplesPerFrame() {
    return n.samplesInFrameTable[this.version === 1 ? 0 : 1][this.layer];
  }
  calculateSideInfoLength() {
    if (this.layer !== 3)
      return 2;
    if (this.channelModeIndex === 3) {
      if (this.version === 1)
        return 17;
      if (this.version === 2 || this.version === 2.5)
        return 9;
    } else {
      if (this.version === 1)
        return 32;
      if (this.version === 2 || this.version === 2.5)
        return 17;
    }
    return null;
  }
  calcSlotSize() {
    return [null, 4, 1, 1][this.layer];
  }
  parseMpegHeader(t, e) {
    this.container = "MPEG", this.bitrateIndex = s(t, e + 2, 0, 4), this.sampRateFreqIndex = s(t, e + 2, 4, 2), this.padding = h(t, e + 2, 6), this.privateBit = h(t, e + 2, 7), this.channelModeIndex = s(t, e + 3, 0, 2), this.modeExtension = s(t, e + 3, 2, 2), this.isCopyrighted = h(t, e + 3, 4), this.isOriginalMedia = h(t, e + 3, 5), this.emphasis = s(t, e + 3, 7, 2), this.version = n.VersionID[this.versionIndex], this.channelMode = n.ChannelMode[this.channelModeIndex], this.codec = `MPEG ${this.version} Layer ${this.layer}`;
    const i = this.calcBitrate();
    if (!i)
      throw new d("Cannot determine bit-rate");
    if (this.bitrate = i * 1e3, this.samplingRate = this.calcSamplingRate(), this.samplingRate == null)
      throw new d("Cannot determine sampling-rate");
  }
  parseAdtsHeader(t, e) {
    o("layer=0 => ADTS"), this.version = this.versionIndex === 2 ? 4 : 2, this.container = `ADTS/MPEG-${this.version}`;
    const i = s(t, e + 2, 0, 2);
    this.codec = "AAC", this.codecProfile = b.AudioObjectTypes[i], o(`MPEG-4 audio-codec=${this.codec}`);
    const r = s(t, e + 2, 2, 4);
    this.samplingRate = b.SamplingFrequencies[r], o(`sampling-rate=${this.samplingRate}`);
    const l = s(t, e + 2, 7, 3);
    this.mp4ChannelConfig = D[l], o(`channel-config=${this.mp4ChannelConfig ? this.mp4ChannelConfig.join("+") : "?"}`), this.frameLength = s(t, e + 3, 6, 2) << 11;
  }
  calcBitrate() {
    if (this.bitrateIndex === 0 || // free
    this.bitrateIndex === 15)
      return null;
    if (this.version && this.bitrateIndex) {
      const t = 10 * Math.floor(this.version) + this.layer;
      return n.bitrate_index[this.bitrateIndex][t];
    }
    return null;
  }
  calcSamplingRate() {
    return this.sampRateFreqIndex === 3 || this.version === null || this.sampRateFreqIndex == null ? null : n.sampling_rate_freq_index[this.version][this.sampRateFreqIndex];
  }
}
n.SyncByte1 = 255;
n.SyncByte2 = 224;
n.VersionID = [2.5, null, 2, 1];
n.LayerDescription = [0, 3, 2, 1];
n.ChannelMode = ["stereo", "joint_stereo", "dual_channel", "mono"];
n.bitrate_index = {
  1: { 11: 32, 12: 32, 13: 32, 21: 32, 22: 8, 23: 8 },
  2: { 11: 64, 12: 48, 13: 40, 21: 48, 22: 16, 23: 16 },
  3: { 11: 96, 12: 56, 13: 48, 21: 56, 22: 24, 23: 24 },
  4: { 11: 128, 12: 64, 13: 56, 21: 64, 22: 32, 23: 32 },
  5: { 11: 160, 12: 80, 13: 64, 21: 80, 22: 40, 23: 40 },
  6: { 11: 192, 12: 96, 13: 80, 21: 96, 22: 48, 23: 48 },
  7: { 11: 224, 12: 112, 13: 96, 21: 112, 22: 56, 23: 56 },
  8: { 11: 256, 12: 128, 13: 112, 21: 128, 22: 64, 23: 64 },
  9: { 11: 288, 12: 160, 13: 128, 21: 144, 22: 80, 23: 80 },
  10: { 11: 320, 12: 192, 13: 160, 21: 160, 22: 96, 23: 96 },
  11: { 11: 352, 12: 224, 13: 192, 21: 176, 22: 112, 23: 112 },
  12: { 11: 384, 12: 256, 13: 224, 21: 192, 22: 128, 23: 128 },
  13: { 11: 416, 12: 320, 13: 256, 21: 224, 22: 144, 23: 144 },
  14: { 11: 448, 12: 384, 13: 320, 21: 256, 22: 160, 23: 160 }
};
n.sampling_rate_freq_index = {
  1: { 0: 44100, 1: 48e3, 2: 32e3 },
  2: { 0: 22050, 1: 24e3, 2: 16e3 },
  2.5: { 0: 11025, 1: 12e3, 2: 8e3 }
};
n.samplesInFrameTable = [
  /* Layer   I    II   III */
  [0, 384, 1152, 1152],
  // MPEG-1
  [0, 384, 1152, 576]
  // MPEG-2(.5
];
const I = {
  len: 4,
  get: (a, t) => new n(a, t)
};
function R(a) {
  return `V${Math.floor((100 - a) / 10)}`;
}
class H extends A {
  constructor() {
    super(...arguments), this.frameCount = 0, this.syncFrameCount = -1, this.countSkipFrameData = 0, this.totalDataLength = 0, this.bitrates = [], this.offset = 0, this.frame_size = 0, this.crc = null, this.calculateEofDuration = !1, this.samplesPerFrame = null, this.buf_frame_header = new Uint8Array(4), this.mpegOffset = null, this.syncPeek = {
      buf: new Uint8Array(C),
      len: 0
    };
  }
  /**
   * Called after ID3 headers have been parsed
   */
  async postId3v2Parse() {
    this.metadata.setFormat("lossless", !1);
    try {
      let t = !1;
      for (; !t; )
        await this.sync(), t = await this.parseCommonMpegHeader();
    } catch (t) {
      if (t instanceof f) {
        if (o("End-of-stream"), this.calculateEofDuration && this.samplesPerFrame !== null) {
          const e = this.frameCount * this.samplesPerFrame;
          if (this.metadata.setFormat("numberOfSamples", e), this.metadata.format.sampleRate) {
            const i = e / this.metadata.format.sampleRate;
            o(`Calculate duration at EOF: ${i} sec.`, i), this.metadata.setFormat("duration", i);
          }
        }
      } else
        throw t;
    }
  }
  /**
   * Called after file has been fully parsed, this allows, if present, to exclude the ID3v1.1 header length
   */
  finalize() {
    const t = this.metadata.format, e = !!this.metadata.native.ID3v1;
    if (this.mpegOffset !== null) {
      if (t.duration && this.tokenizer.fileInfo.size) {
        const i = this.tokenizer.fileInfo.size - this.mpegOffset - (e ? 128 : 0);
        t.codecProfile && t.codecProfile[0] === "V" && this.metadata.setFormat("bitrate", i * 8 / t.duration);
      }
      if (this.tokenizer.fileInfo.size && t.codecProfile === "CBR") {
        const i = this.tokenizer.fileInfo.size - this.mpegOffset - (e ? 128 : 0);
        if (this.frame_size !== null && this.samplesPerFrame !== null) {
          const r = Math.round(i / this.frame_size) * this.samplesPerFrame;
          if (this.metadata.setFormat("numberOfSamples", r), t.sampleRate && !t.duration) {
            const l = r / t.sampleRate;
            o("Calculate CBR duration based on file size: %s", l), this.metadata.setFormat("duration", l);
          }
        }
      }
    }
  }
  async sync() {
    let t = !1;
    for (; ; ) {
      let e = 0;
      if (this.syncPeek.len = await this.tokenizer.peekBuffer(this.syncPeek.buf, { length: C, mayBeLess: !0 }), this.syncPeek.len <= 163)
        throw new f();
      for (; ; ) {
        if (t && (this.syncPeek.buf[e] & 224) === 224) {
          this.buf_frame_header[0] = n.SyncByte1, this.buf_frame_header[1] = this.syncPeek.buf[e], await this.tokenizer.ignore(e), o(`Sync at offset=${this.tokenizer.position - 1}, frameCount=${this.frameCount}`), this.syncFrameCount === this.frameCount && (o(`Re-synced MPEG stream, frameCount=${this.frameCount}`), this.frameCount = 0, this.frame_size = 0), this.syncFrameCount = this.frameCount;
          return;
        }
        if (t = !1, e = this.syncPeek.buf.indexOf(n.SyncByte1, e), e === -1) {
          if (this.syncPeek.len < this.syncPeek.buf.length)
            throw new f();
          await this.tokenizer.ignore(this.syncPeek.len);
          break;
        }
        ++e, t = !0;
      }
    }
  }
  /**
   * Combined ADTS & MPEG (MP2 & MP3) header handling
   * @return {Promise<boolean>} true if parser should quit
   */
  async parseCommonMpegHeader() {
    this.frameCount === 0 && (this.mpegOffset = this.tokenizer.position - 1), await this.tokenizer.peekBuffer(this.buf_frame_header.subarray(1), { length: 3 });
    let t;
    try {
      t = I.get(this.buf_frame_header, 0);
    } catch (e) {
      if (await this.tokenizer.ignore(1), e instanceof Error)
        return this.metadata.addWarning(`Parse error: ${e.message}`), !1;
      throw e;
    }
    return await this.tokenizer.ignore(3), this.metadata.setFormat("container", t.container), this.metadata.setFormat("codec", t.codec), this.metadata.setFormat("lossless", !1), this.metadata.setFormat("sampleRate", t.samplingRate), this.frameCount++, t.version !== null && t.version >= 2 && t.layer === 0 ? this.parseAdts(t) : this.parseAudioFrameHeader(t);
  }
  /**
   * @return {Promise<boolean>} true if parser should quit
   */
  async parseAudioFrameHeader(t) {
    this.metadata.setFormat("numberOfChannels", t.channelMode === "mono" ? 1 : 2), this.metadata.setFormat("bitrate", t.bitrate), this.frameCount < 20 * 1e4 && o("offset=%s MP%s bitrate=%s sample-rate=%s", this.tokenizer.position - 4, t.layer, t.bitrate, t.samplingRate);
    const e = t.calcSlotSize();
    if (e === null)
      throw new d("invalid slot_size");
    const i = t.calcSamplesPerFrame();
    o(`samples_per_frame=${i}`);
    const r = i / 8;
    if (t.bitrate !== null && t.samplingRate != null) {
      const l = r * t.bitrate / t.samplingRate + (t.padding ? e : 0);
      this.frame_size = Math.floor(l);
    }
    if (this.audioFrameHeader = t, t.bitrate !== null && this.bitrates.push(t.bitrate), this.frameCount === 1)
      return this.offset = I.len, await this.skipSideInformation(), !1;
    if (this.frameCount === 3) {
      if (this.areAllSame(this.bitrates)) {
        if (this.samplesPerFrame = i, this.metadata.setFormat("codecProfile", "CBR"), this.tokenizer.fileInfo.size)
          return !0;
      } else if (this.metadata.format.duration)
        return !0;
      if (!this.options.duration)
        return !0;
    }
    return this.options.duration && this.frameCount === 4 && (this.samplesPerFrame = i, this.calculateEofDuration = !0), this.offset = 4, t.isProtectedByCRC ? (await this.parseCrc(), !1) : (await this.skipSideInformation(), !1);
  }
  async parseAdts(t) {
    const e = new Uint8Array(3);
    if (await this.tokenizer.readBuffer(e), t.frameLength += s(e, 0, 0, 11), this.totalDataLength += t.frameLength, this.samplesPerFrame = 1024, t.samplingRate !== null) {
      const i = t.samplingRate / this.samplesPerFrame, l = 8 * (this.frameCount === 0 ? 0 : this.totalDataLength / this.frameCount) * i + 0.5;
      this.metadata.setFormat("bitrate", l), o(`frame-count=${this.frameCount}, size=${t.frameLength} bytes, bit-rate=${l}`);
    }
    if (await this.tokenizer.ignore(t.frameLength > 7 ? t.frameLength - 7 : 1), this.frameCount === 3)
      if (this.metadata.setFormat("codecProfile", t.codecProfile), t.mp4ChannelConfig && this.metadata.setFormat("numberOfChannels", t.mp4ChannelConfig.length), this.options.duration)
        this.calculateEofDuration = !0;
      else
        return !0;
    return !1;
  }
  async parseCrc() {
    return this.crc = await this.tokenizer.readNumber(v), this.offset += 2, this.skipSideInformation();
  }
  async skipSideInformation() {
    if (this.audioFrameHeader) {
      const t = this.audioFrameHeader.calculateSideInfoLength();
      if (t !== null) {
        await this.tokenizer.readToken(new S(t)), this.offset += t, await this.readXtraInfoHeader();
        return;
      }
    }
  }
  async readXtraInfoHeader() {
    const t = await this.tokenizer.readToken(w);
    switch (this.offset += w.len, t) {
      case "Info":
        return this.metadata.setFormat("codecProfile", "CBR"), this.readXingInfoHeader();
      case "Xing": {
        const i = await this.readXingInfoHeader();
        if (i.vbrScale !== null) {
          const r = R(i.vbrScale);
          this.metadata.setFormat("codecProfile", r);
        }
        return null;
      }
      case "Xtra":
        break;
      case "LAME": {
        const i = await this.tokenizer.readToken(u);
        if (this.frame_size !== null && this.frame_size >= this.offset + u.len)
          return this.offset += u.len, this.metadata.setFormat("tool", `LAME ${i}`), await this.skipFrameData(this.frame_size - this.offset), null;
        this.metadata.addWarning("Corrupt LAME header");
        break;
      }
    }
    const e = this.frame_size - this.offset;
    return e < 0 ? this.metadata.addWarning(`Frame ${this.frameCount}corrupt: negative frameDataLeft`) : await this.skipFrameData(e), null;
  }
  /**
   * Ref: http://gabriel.mp3-tech.org/mp3infotag.html
   * @returns {Promise<string>}
   */
  async readXingInfoHeader() {
    const t = this.tokenizer.position, e = await L(this.tokenizer);
    if (this.offset += this.tokenizer.position - t, e.lame && (this.metadata.setFormat("tool", `LAME ${z(e.lame.version)}`), e.lame.extended && (this.metadata.setFormat("trackPeakLevel", e.lame.extended.track_peak), e.lame.extended.track_gain && this.metadata.setFormat("trackGain", e.lame.extended.track_gain.adjustment), e.lame.extended.album_gain && this.metadata.setFormat("albumGain", e.lame.extended.album_gain.adjustment), this.metadata.setFormat("duration", e.lame.extended.music_length / 1e3))), e.streamSize && this.audioFrameHeader && e.numFrames !== null) {
      const r = this.audioFrameHeader.calcDuration(e.numFrames);
      return this.metadata.setFormat("duration", r), o("Get duration from Xing header: %s", this.metadata.format.duration), e;
    }
    const i = this.frame_size - this.offset;
    return await this.skipFrameData(i), e;
  }
  async skipFrameData(t) {
    if (t < 0)
      throw new d("frame-data-left cannot be negative");
    await this.tokenizer.ignore(t), this.countSkipFrameData += t;
  }
  areAllSame(t) {
    const e = t[0];
    return t.every((i) => i === e);
  }
}
export {
  d as MpegContentError,
  H as MpegParser
};
